# CHANGELOG

Все значимые изменения в ChaosInjector будут документированы в этом файле.

Формат основан на [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
и этот проект следует [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

[English version](CHANGELOG.md)

## [Unreleased]

- Пока нет изменений. Приветствуются вклады для будущих функций, таких как поддержка async или кастомные no-op handlers.

## [0.2.0] - 2025-07-26

### Добавлено
- Введён метод `create_proxy` для создания недеструктивных прокси, сохраняющих состояние и типизацию оригинального объекта, включая поддержку TypeVar generics (#3, #4). Это позволяет применять хаос без мутации источника, повышая гибкость для параллельного использования.
- Добавлена логика копирования состояния для `__dict__` с использованием copy.deepcopy и ручного setattr для `__slots__` в создании прокси, обеспечивая совместимость с slotted-классами и сложными объектами вроде dataclasses (#5).
- Реализованы overload-аннотации для внутреннего метода `__inject`, улучшая проверку типов инструментами вроде mypy и PyCharm, для лучшей интеграции с IDE и предотвращения ошибок (#6).
- Добавлена валидация для словаря method_probs, проверяющая, что все вероятности в [0, 1], с поднятием ValueError для некорректных значений и детальными сообщениями об ошибках (#7).
- Внедрён декоратор @wraps в `__handle` для сохранения метаданных оригинального __getattribute__, облегчая отладку и интроспекцию (#8).

### Изменено
- Рефакторинг общей логики между `inject` и `create_proxy` в приватный метод `__inject` с overloads, уменьшая дублирование кода и повышая поддерживаемость (#2).
- Обновлён README.md примерами для нового режима прокси, поддержкой нескольких языков и детальными функциями, включая сохранение совместимости с isinstance (#1).
- Мелкие переименования и реорганизация внутренних методов (например, probability в probability для согласованности) в соответствии с Pythonic-стандартами.

### Исправлено
- Обеспечено сохранение совместимости isinstance в прокси путём динамического наследования от оригинального класса, решая потенциальные проблемы с проверкой типов в пользовательском коде (#9).
- Гарантировано корректное глубокое копирование для непиклируемых атрибутов в __dict__, с fallback для slotted-классов (#10).

### Устарело
- Ничего. Все функции из 0.1.0 остаются полностью поддерживаемыми.

### Удалено
- Ничего. Обратная совместимость сохранена.

### Безопасность
- Ничего. В этом релизе не адресованы уязвимости безопасности, но улучшенная валидация снижает риски неожиданного поведения от некорректного ввода.

## [0.1.0] - 2025-07-25

### Добавлено
- Начальный релиз ChaosInjector с основной функциональностью: in-place инъекция вероятностного поведения через метод `inject`.
- Поддержка probability, callable decider и вероятностей по методам.
- Базовая обработка no-op для callable и non-callable атрибутов.
- Валидация диапазонов probability.
- Полные unit-тесты, покрывающие ключевые сценарии.

### Изменено
- Н/Д (начальный релиз).

### Исправлено
- Н/Д (начальный релиз).

### Устарело
- Н/Д.

### Удалено
- Н/Д.

### Безопасность
- Н/Д.